From 8d035e98cef81d3f5a241a9dd5692528a0196d3f Mon Sep 17 00:00:00 2001
From: Min Chen <chenm003@163.com>
Date: Fri, 15 Nov 2013 13:12:15 +0800
Subject: [PATCH 1/3] asm: residual buffer is alignment to size, so we can use
 alignment load instruction

---
 source/Lib/TLibEncoder/TEncSearch.cpp |    4 ++++
 source/common/x86/pixel-util.asm      |   26 ++++++++++----------------
 2 files changed, 14 insertions(+), 16 deletions(-)

diff --git a/source/Lib/TLibEncoder/TEncSearch.cpp b/source/Lib/TLibEncoder/TEncSearch.cpp
index 4a876c7..51f4b6d 100644
--- a/source/Lib/TLibEncoder/TEncSearch.cpp
+++ b/source/Lib/TLibEncoder/TEncSearch.cpp
@@ -502,6 +502,8 @@ void TEncSearch::xIntraCodingLumaBlk(TComDataCU* cu,
     }
 
     //===== reconstruction =====
+    assert(((uint32_t)residual & (width - 1)) == 0);
+    assert(width <= 32);
     primitives.calcrecon[size](pred, residual, recon, reconQt, reconIPred, stride, MAX_CU_SIZE, reconIPredStride);
 
     //===== update distortion =====
@@ -636,6 +638,8 @@ void TEncSearch::xIntraCodingChromaBlk(TComDataCU* cu,
     }
 
     //===== reconstruction =====
+    assert(((uint32_t)residual & (width - 1)) == 0);
+    assert(width <= 32);
     primitives.calcrecon[size](pred, residual, recon, reconQt, reconIPred, stride, MAX_CU_SIZE / 2, reconIPredStride);
 
     //===== update distortion =====
diff --git a/source/common/x86/pixel-util.asm b/source/common/x86/pixel-util.asm
index 6e41ac6..c513a31 100644
--- a/source/common/x86/pixel-util.asm
+++ b/source/common/x86/pixel-util.asm
@@ -239,10 +239,10 @@ INIT_XMM sse4
 cglobal calcRecons16
 %if ARCH_X86_64 == 1
     DECLARE_REG_TMP 0,1,2,3,4,5,6,7,8
-    PROLOGUE 6,9,5
+    PROLOGUE 6,9,3
 %else
     DECLARE_REG_TMP 0,1,2,3,4,5
-    PROLOGUE 6,7,5
+    PROLOGUE 6,7,3
     %define t6      r6m
     %define t6d     r6d
     %define t7      r7m
@@ -265,10 +265,8 @@ cglobal calcRecons16
     movu        m2, [t0]
     pmovzxbw    m1, m2
     punpckhbw   m2, m0
-    movu        m3, [t1]
-    movu        m4, [t1 + 16]
-    paddw       m1, m3
-    paddw       m2, m4
+    paddw       m1, [t1]
+    paddw       m2, [t1 + 16]
     packuswb    m1, m2
 
     ; store recon[] and recipred[]
@@ -296,10 +294,10 @@ INIT_XMM sse4
 cglobal calcRecons32
 %if ARCH_X86_64 == 1
     DECLARE_REG_TMP 0,1,2,3,4,5,6,7,8
-    PROLOGUE 6,9,7
+    PROLOGUE 6,9,5
 %else
     DECLARE_REG_TMP 0,1,2,3,4,5
-    PROLOGUE 6,7,7
+    PROLOGUE 6,7,5
     %define t6      r6m
     %define t6d     r6d
     %define t7      r7m
@@ -326,16 +324,12 @@ cglobal calcRecons32
     pmovzxbw    m3, m4
     punpckhbw   m4, m0
 
-    movu        m5, [t1 + 0 * 16]
-    movu        m6, [t1 + 1 * 16]
-    paddw       m1, m5
-    paddw       m2, m6
+    paddw       m1, [t1 + 0 * 16]
+    paddw       m2, [t1 + 1 * 16]
     packuswb    m1, m2
 
-    movu        m5, [t1 + 2 * 16]
-    movu        m6, [t1 + 3 * 16]
-    paddw       m3, m5
-    paddw       m4, m6
+    paddw       m3, [t1 + 2 * 16]
+    paddw       m4, [t1 + 3 * 16]
     packuswb    m3, m4
 
     ; store recon[] and recipred[]
-- 
1.7.9.msysgit.0

